open Absyn;;

type symk = VarS of ty | NameS of ty;;
val pp_symk : symk Printer.printer;;

type tyk  = DataKd | NameKd | TypeKd;;
val pp_tyk : tyk Printer.printer;;

type ctx  = symk Varmap.t;;
type tctx = tyk Varmap.t;;
type ty_abbrev = ty list -> ty;;
type ksg  = (kind*Unique.uniq*ty_abbrev option) Nstbl.t;;
type tsg_entry = {is_def:bool; sym_id:Unique.uniq; sym_ty:ty};;
type tsg  = tsg_entry Nstbl.t;; 
type sg   = {ksg:ksg; 
	     tsg:tsg;
	     stbl:(Unique.uniq, Nstbl.sym) Hashtbl.t};;

val init_sg : unit -> sg;;

type eqns = (Types.var * Absyn.ty) list;;
type tcenv = Varset.t * tctx * ctx * eqns;;

val empty_env : tcenv;;

